/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : jeudi 26 avril 2007 - 10h54
		* AUTHOR       : gilles bailly ( gilles.bailly@enst.fr )
			* FILENAME     : Demo.cpp
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/
//Demo.cpp
#include <sstream>
#include <iostream>
#include <string>
#include <QWidget>
#include <QObject>
#include <QString>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QSpacerItem>
#include <QLabel>
#include <QMouseEvent>
#include "RadialMenu.h"
#include "Demo.h"
#include "Menu.h"

using namespace std;

std::vector<RadioButtonMenu*> RadioButtonMenu::radioButtonMenu;
Demo* RadioButtonMenu::demo =0;


//====================================================================
//====================================================================
//====================================================================

RadioButtonMenu* RadioButtonMenu::createRadioButtonMenu(const QString& text, QWidget* _parent, RadialMenu* _m){
	demo = qobject_cast<Demo *> (_parent );
	RadioButtonMenu* rbm = new RadioButtonMenu( text, _parent, _m);
	RadioButtonMenu::radioButtonMenu.push_back(rbm);
	return rbm;
}




//==============
void RadioButtonMenu::desactive(){}

//===============
void RadioButtonMenu::active(){
	if(demo){
		demo->menu = m;
	}
	
}

//==============
RadioButtonMenu::RadioButtonMenu(const QString& text, QWidget* parent, RadialMenu* _m):QRadioButton(text, parent), m(_m){
	
}

//==============
RadioButtonMenu::~RadioButtonMenu(){}




//===================================================================================
//===================================================================================
//===================================================================================
//==============
Demo::Demo(QWidget* parent):QWidget(parent){
	setMouseTracking(true);
	labCommand.setParent( this );
	labCommand.move( 400,20 );
	labCommand.resize(300, 30 );
	labCommand.setFont( QFont("Helvetica", 16) );
	menu = 0;
	std::string* label = new std::string[150];
	for(int i = 0; i<150; i++){
		std::stringstream ss;
		ss << i << std::flush;
		std::string num ;
		ss>>num;
		label[i] = "label "+ num;
	}
	
	
	QWidget* buttonBox = new QWidget(this);
	QVBoxLayout *vlayout = new QVBoxLayout();
	
	vlayout->addWidget(new QLabel());
	
	RadioButtonMenu* rbm;
	
	
	

	/*
	//-------------
	PolygonMenu& polygonMenu = *new PolygonMenu(this);
	for(int i = 0; i< 16; i++){
		PolygonSector *sector = new PolygonSector(label[i].c_str(), &polygonMenu);
		polygonMenu.addPolygonSector(sector);
	}
	polygonMenu.initialize();
	
	rbm = RadioButtonMenu::createRadioButtonMenu("polygon", this, &polygonMenu);
	connect( rbm, SIGNAL( clicked() ), rbm, SLOT( active() ));
	vlayout->addWidget( rbm );
	*/
	
	
	//====================
	
	tabIdItem3.push_back( 0 ); tabIdItem3.push_back( 16 ); tabIdItem3.push_back( 8 ); tabIdItem3.push_back( 9 );
	tabIdItem3.push_back( 1 ); tabIdItem3.push_back( 26 ); tabIdItem3.push_back( 18 ); tabIdItem3.push_back( 2 );
	tabIdItem3.push_back( 10 ); tabIdItem3.push_back( 3 ); tabIdItem3.push_back( 20 ); tabIdItem3.push_back( 4 );
	tabIdItem3.push_back( 12 ); tabIdItem3.push_back( 5 ); tabIdItem3.push_back( 22 ); tabIdItem3.push_back( 14 );
	
	/*
	tabIdItem3.push_back( 24); tabIdItem3.push_back( 32);
	
	tabIdItem3.push_back( 34); tabIdItem3.push_back( 42);
	
	tabIdItem3.push_back( 28); tabIdItem3.push_back( 36 );
	
	tabIdItem3.push_back( 6 );
	*/
	
		labels = new std::string[20];
		/*
		labels[0] = "Espion";
		labels[1] = "Bambin";
		labels[2] = "Alarme";
		labels[3] = "Avocat";
		labels[4] = "Moteur";
		labels[5] = "Soleil";
		labels[6] = "Argent";
		labels[7] = "Enfant";
		labels[8] = "Soldat";
		labels[9] = "Junior";
		labels[10]= "Lardon";
		labels[11] = "Ivoire";
		labels[12 ] = "Piston";
		labels[13] = "Jambon";
		labels[14] = "Marbre";
		labels[15] = "Acteur";
	*/
		
		labels[0] = "open";
		labels[1] = "Close";
		labels[2] = "New";
		labels[3] = "Redo";
		labels[4] = "Undo";
		labels[5] = "  Versions  ";
		labels[6] = "Save html";
		labels[7] = "Save";
		labels[8] = "Save as";
		labels[9] = "Help";
		labels[10]= "Cut";
		labels[11] = "Paste";
		labels[12 ] = "Copy";
		labels[13] = "Quit";
		labels[14] = "Send to";
		labels[15] = "  Properties  ";
	
	
	
		
		
	std::vector< int > tabIdItem;
	tabIdItem.push_back( 0 ); tabIdItem.push_back( 16 ); tabIdItem.push_back( 8 ); tabIdItem.push_back( 9 );
	tabIdItem.push_back( 1 ); tabIdItem.push_back( 26 ); tabIdItem.push_back( 18 ); tabIdItem.push_back( 2 );
	tabIdItem.push_back( 10 ); tabIdItem.push_back( 7 ); tabIdItem.push_back( 20 ); tabIdItem.push_back( 4 );
	tabIdItem.push_back( 12 ); tabIdItem.push_back( 5 ); tabIdItem.push_back( 22 ); tabIdItem.push_back( 14 );
	
	FlowerGroupingMenu* flower = new FlowerGroupingMenu( this );
	//flower->setMenuFont( QFont("Helvetica", 16) );
	
	for(int i = 0; i< 16; i++){
		FlowerGroupingSector *sector = new FlowerGroupingSector(labels[i].c_str(), flower);
		flower->addSpecificSector( sector, tabIdItem[ i  ]   );
	}
	
	flower->initialize();
	connect(flower, SIGNAL(finalItemSelected(int)),
			this, SLOT(updateCommandName(int)) );
	flower->hide();
	

	
	
	rbm = RadioButtonMenu::createRadioButtonMenu("Flower Menu", this, flower);
	connect( rbm, SIGNAL( clicked() ), rbm, SLOT( active() ));
	vlayout->addWidget( rbm );
	
	buttonBox->setLayout(vlayout);
	
	menu = flower;
	
	//rbm->setChecked( true );
	
}

#include <QPainter>
//===================================
void Demo::paintEvent( QPaintEvent* e ){
	//QPainter p( this );
	//p.setBrush( Qt::black );
	//p.fillRect( 0, 0, width(), height(), Qt::black );

}

//===================================
void Demo::mousePressEvent(QMouseEvent* e){
	if(menu) menu->start(this, e);
	else std::cerr<<"demo mouse press menu is null"<<std::endl;
}


//================================
void Demo::updateCommandName( int commandId  ){

	int num = -1;
	for( unsigned int i = 0; i < tabIdItem3.size() ; i++){
		if( tabIdItem3[ i ] == commandId ){
			num = (int)i;	
		} 
	}
	if( num == -1){
		labCommand.setText( "gesture not recognized");	
		return;
	}else{
	
	string name = labels[ num ];
	labCommand.setText( name.c_str() );	
	}
}


//==============
Demo::~Demo(){}


