/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : mercredi 18 juillet 2007 - 14h13
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : FlowerRecognizer.h
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/
#ifndef FLOWERRECOGNIZER_H
#define FLOWERRECOGNIZER_H

#include <vector>
#include <QString>
#include <QFile>
#include <QTextStream>
#include <QPointF>

class KPlusProche{
public:
	KPlusProche();
	~KPlusProche();
	
	std::vector< std::pair<int, float> > kPlusProche;
	int getItem();
	//std::vector<>
	int k;
};

//================
class FlowerRecognizer
{
public:
	FlowerRecognizer();
	virtual  ~FlowerRecognizer();
	
	static float startI0;
	static float startI1;
	static float endI0;
	static float endI1;
	
	//========================
	virtual void getKPPFeature( std::vector< QPointF >& , float* feature  );
	float getTotalAngle( std::vector< QPointF >& stroke );
	float getAngle( float x1, float y1, float x2, float y2 );
	float getDimensions( std::vector< QPointF >& stroke, float& angleD, float& angleF, float& distBoucle );
	void loadGesturesBase( const QString& nameFile );
	void getProbForGesture(  float* featureGesture, KPlusProche& result );
	std::vector< float* >	gesturesBase;
	
protected:
	void insert(int numItem, float dist, KPlusProche& result);
	void decalToRight( std::vector< std:: pair< int, float > >& v, int i );
	float distanceCarre( float* gestureFeature, float* baseFeature);
	
	
private:
	
};
//
#endif // FLOWERRECOGNIZER_H
