/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : mercredi 23 mai 2007 - 13h40
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : GMConfiguration.h
			* LICENSE      : GPL
			* COMMENTARY   :
cette classe est utilis pour connettre la configuration du menu
		necessaire pour savoir quel amplitude d'angle, on doit affecter  quel secteurs
		********************************************************************************************************/
#ifndef GMCONFIGURATION_H
#define GMCONFIGURATION_H
//

#include <vector>

class FlowerGroupingMenu;
class GMConfiguration
{
public:
	GMConfiguration(FlowerGroupingMenu* _menu);
	virtual void defineConfiguration(int* _dir, int* _branch, int _nb);
	virtual ~GMConfiguration();
	virtual bool hasOnAxes();
	virtual bool hasOffAxes();
	virtual int getAmplForDir(int _dir);
	virtual int getNbBranchForDir(int _dir);
	virtual int getAngle8From64( int i);
	virtual int getBranch(int angleG, int angle, int ampl, int nbBranch);
	//
private:
	FlowerGroupingMenu* menu;
	std::vector<int> dirSector;
	std::vector<int> branchSector;
};
//
#endif // GMCONFIGURATION_H
