/********************************************************************************************************
 * PROGRAM      : menus
 * DATE - TIME  : jeudi 02 aot 2007 - 14h51
 * AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
 * FILENAME     : Arrow.cpp
 * LICENSE      : GPL
 * COMMENTARY   : 
 ********************************************************************************************************/
//Arrow.cpp

#include "Arrow.h"
#include <math.h>
#include <QPainter>
static const double Pi = 3.14159265358979323846264338327950288419717;
static double TwoPi = 2.0 * Pi;

//================
Arrow::Arrow(const QPointF& start, const QPointF& end, const QPointF& control) :QPainterPath(start), poly(0){
	source = false; target = true;
	arrowSize = 10.; 
	quadTo(control, end);
}

//====================
Arrow::~Arrow(){}

//====================
void Arrow::optimize(){
		poly = new QPolygonF(toFillPolygon());
		poly->erase(poly->end() -1);
}

//===================
void Arrow::setArrow(bool _source, bool _target){
	source = _source;
	target = _target;
}

//===================
void Arrow::draw(QPainter& p){
		if(!poly) optimize();
	if (poly->size() <2) return;		
	
	//====== draw line ===
	for(int i =0; i < poly->size() -1; i++){
		p.drawLine( (*poly)[i], (*poly)[i+1] );
	}		

	//===== target arrow ==
	QPointF dest = (*poly)[poly->size() -1];
	QLineF line( (*poly)[poly->size() -2], (*poly)[poly->size() -1] );
	
	double angleT = ::acos(line.dx() / line.length());
     if (line.dy() >= 0)
         angleT = TwoPi - angleT;

     
     QPointF destArrowP1 = dest + QPointF(sin(angleT - Pi / 3) * arrowSize,
                                               cos(angleT - Pi / 3) * arrowSize);
     QPointF destArrowP2 = dest + QPointF(sin(angleT - Pi + Pi / 3) * arrowSize,
                                               cos(angleT - Pi + Pi / 3) * arrowSize);
	
	
                                               
    //===== target arrow ==
	QPointF sourcePoint = (*poly)[0];
	QLineF lineS( (*poly)[0], (*poly)[1] );
	
	double angleS = ::acos(lineS.dx() / lineS.length());
     if (line.dy() >= 0)
         angleS = TwoPi - angleS;                                           
		QPointF sourceArrowP1 = sourcePoint + QPointF(sin(angleS + Pi / 3) * arrowSize,
                                                   cos(angleS + Pi / 3) * arrowSize);
     QPointF sourceArrowP2 = sourcePoint + QPointF(sin(angleS + Pi - Pi / 3) * arrowSize,
                                                   cos(angleS + Pi - Pi / 3) * arrowSize);
	if(source){
		 p.drawPolygon(QPolygonF() << sourcePoint << sourceArrowP1 << sourceArrowP2);    	
	}
	if(target){
		p.drawPolygon(QPolygonF() << dest << destArrowP1 << destArrowP2);	
	}
                                                   
}