/********************************************************************************************************
		* PROGRAM      : menus
		* DATE - TIME  : samedi 28 avril 2007 - 12h21
		* AUTHOR       : gilles bailly ( gilles.bailly enst.fr )
			* FILENAME     : MenuGestureRecognizer.h
			* LICENSE      : GPL
			* COMMENTARY   :
********************************************************************************************************/


#ifndef MENUGESTURERECOGNIZER_H
#define MENUGESTURERECOGNIZER_H

#include <vector>
#include <QPointF>

typedef enum { Up, Down, Left, Right, UpRight, UpLeft, DownRight, DownLeft, RightUp, RightDown, LeftUp, LeftDown, NoMatch} Direction;


class MenuGestureRecognizer
{
public:
	static QPointF pointNonValid;
	MenuGestureRecognizer( int minimumMovement = 5,
			int maxMovement = 5,
			double minimumMatch = 0.9 );
	~MenuGestureRecognizer();
	
	
	QPointF getOriginOfStroke();
	QPointF getEndOfStroke();
	void startGesture( int x, int y );
	void addPoint( int x, int y );
	void endGesture( int x, int y );
	void abortGesture();
	int getGestureSize();
	Direction recognize8Gesture(int debut, int fin);
	Direction recognize8GestureL(float debut, float fin);
	
	Direction recognize12Gesture(int debut, int fin);
	Direction recognize12GestureL(float debut, float fin);
	
	int recognize64GestureL(float debut, float fin);
	int recognize64Gesture(int debut, int fin);
	
	Direction recognize4Gesture(int debut, int fin);
	int getLenght();
	int getNbPoints();
	Direction recognizeGesture();
	static double angleAt(double x, double y);
	static double angleAtFlower(double x, double y);
	
	const std::vector<QPointF>& getList()const{ return posList; }
private:
	
	std::vector<QPointF> posList;
	int minMovement;
	int maxMovement;
	double minMatch;
	
	
};


#endif // MENUGESTURERECOGNIZER_H
